Xcode 4 isn't available on DVD, but is available for download from
[obnox/wireshark/wip.git] / macosx-setup.sh
1 #!/bin/sh
2 # Setup development environment on Mac OS X (tested with 10.6.8 and Xcode 3.2.6)
3 #
4 # $Id$
5 #
6 # Trying to follow "Building Wireshark on SnowLeopard"
7 # given by Michael Tuexen at
8 # http://nplab.fh-muenster.de/groups/wiki/wiki/fb7a4/Building_Wireshark_on_SnowLeopard.html 
9 #
10
11 #
12 # Versions to download and install.
13 #
14 # These are required.
15 #
16 GETTEXT_VERSION=0.18.1.1
17 GLIB_VERSION=2.29.8
18 #
19 # pkg-config 0.26 appears to have broken the "we have our own GLib"
20 # stuff, even if you explicitly set GLIB_CFLAGS and GLIB_LIBS.
21 # Life's too short to work around the circular dependency in a script,
22 # so we use 0.25 instead.
23 #
24 PKG_CONFIG_VERSION=0.26
25 ATK_VERSION=2.0.1
26 PANGO_VERSION=1.29.3
27 GDK_PIXBUF_VERSION=2.23.4
28 GTK_VERSION=2.24.5
29
30 #
31 # These are optional.  Comment them out if you don't want them.
32 #
33 LIBSMI_VERSION=0.4.8
34 GEOIP_VERSION=1.4.5
35 #
36 # libgpg-error is required for libgcrypt.
37 #
38 LIBGPG_ERROR_VERSION=1.10
39 #
40 # libgcrypt is required for GnuTLS.
41 # XXX - the link for "Libgcrypt source code" at
42 # http://www.gnupg.org/download/#libgcrypt is for 1.5.0, and is a bzip2
43 # file, but http://directory.fsf.org/project/libgcrypt/ lists only
44 # 1.4.6.
45 #
46 LIBGCRYPT_VERSION=1.4.6
47 GNUTLS_VERSION=2.12.7
48 LUA_VERSION=5.1.4
49 PORTAUDIO_VERSION=pa_stable_v19_20110326
50 #
51 # XXX - they appear to have an unversioned gzipped tarball for the
52 # current version; should we just download that, with some other
53 # way of specifying whether to download the GeoIP API?
54 #
55 GEOIP_VERSION=1.4.8
56
57 #
58 # You need Xcode installed to get the compilers.
59 #
60 if [ ! -x /usr/bin/xcodebuild ]; then
61         echo "Please install Xcode first (should be available on DVD or from http://developer.apple.com/xcode/index.php)."
62         exit 1
63 fi
64
65 #
66 # You also need the X11 SDK; with at least some versions of OS X and
67 # Xcode, that is, I think, an optional install.  (Or it might be
68 # installed with X11, but I think *that* is an optional install on
69 # at least some versions of OS X.)
70 #
71 if [ ! -d /usr/X11/include ]; then
72         echo "Please install X11 and the X11 SDK first."
73         exit 1
74 fi
75
76 #
77 # Do we have permission to write in /usr/local?
78 #
79 # If so, assume we have permission to write in its subdirectories.
80 # (If that's not the case, this test needs to check the subdirectories
81 # as well.)
82 #
83 # If not, do "make install" with sudo.
84 #
85 if [ -w /usr/local ]
86 then
87         DO_MAKE_INSTALL="make install"
88 else
89         DO_MAKE_INSTALL="sudo make install"
90 fi
91
92 export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig:/usr/X11/lib/pkgconfig
93
94 #
95 # Do all the downloads and untarring in a subdirectory, so all that
96 # stuff can be removed once we've installed the support libraries.
97 #
98 if [ ! -d macosx-support-libs ]
99 then
100         mkdir macosx-support-libs || exit 1
101 fi
102 cd macosx-support-libs
103
104 #
105 # Start with GNU gettext; GLib requires it, and OS X doesn't have it
106 # or a BSD-licensed replacement.
107 #
108 # At least on Lion with Xcode 4, _FORTIFY_SOURCE gets defined as 2
109 # by default, which causes, for example, stpncpy to be defined as
110 # a hairy macro that collides with the GNU gettext configure script's
111 # attempts to workaround AIX's lack of a declaration for stpncpy,
112 # with the result being a huge train wreck.  Define _FORTIFY_SOURCE
113 # as 0 in an attempt to keep the trains on separate tracks.
114 #
115 echo "Downloading, building, and installing GNU gettext:"
116 curl -O http://ftp.gnu.org/pub/gnu/gettext/gettext-$GETTEXT_VERSION.tar.gz || exit 1
117 tar xf gettext-$GETTEXT_VERSION.tar.gz || exit 1
118 cd gettext-$GETTEXT_VERSION
119 CFLAGS="-D_FORTIFY_SOURCE=0" ./configure || exit 1
120 make -j 3 || exit 1
121 $DO_MAKE_INSTALL || exit 1
122 cd ..
123
124 echo "Downloading, building, and installing GLib:"
125 glib_dir=`expr $GLIB_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
126 curl -L -O http://ftp.gnome.org/pub/gnome/sources/glib/$glib_dir/glib-$GLIB_VERSION.tar.bz2 || exit 1
127 bzcat glib-$GLIB_VERSION.tar.bz2 | tar xf - || exit 1
128 cd glib-$GLIB_VERSION
129 #
130 # OS X ships with libffi, but doesn't provide its pkg-config file;
131 # explicitly specify LIBFFI_CFLAGS and LIBFFI_LIBS, so the configure
132 # script doesn't try to use pkg-config to get the appropriate
133 # CFLAGS and LIBS.
134 #
135 LIBFFI_CFLAGS="-I/usr/include/ffi" LIBFFI_LIBS="-L/usr/lib" ./configure || exit 1
136 #
137 # Mac OS X on 64-bit platforms provides libiconv, but in a form that
138 # confuses GLib.
139 #
140 patch -p1 < ../../macosx-support-lib-patches/glib-gconvert.patch || exit 1
141 make -j 3 || exit 1
142 # Apply patch: we depend on libffi, but pkg-config doesn't get told.
143 patch -p0 <../../macosx-support-lib-patches/glib-pkgconfig.patch || exit 1
144 $DO_MAKE_INSTALL || exit 1
145 cd ..
146
147 echo "Downloading, building, and installing pkg-config:"
148 curl -O http://pkgconfig.freedesktop.org/releases/pkg-config-$PKG_CONFIG_VERSION.tar.gz || exit 1
149 tar xf pkg-config-$PKG_CONFIG_VERSION.tar.gz || exit 1
150 cd pkg-config-$PKG_CONFIG_VERSION
151 # Avoid another pkgconfig call
152 GLIB_CFLAGS="-I/usr/local/include/glib-2.0 -I/usr/local/lib/glib-2.0/include" GLIB_LIBS="-L/usr/local/lib -lglib-2.0 -lintl" ./configure || exit 1
153 # ./configure || exit 1
154 make -j 3 || exit 1
155 $DO_MAKE_INSTALL || exit 1
156 cd ..
157
158 #
159 # Now we have reached a point where we can build everything but
160 # the GUI (Wireshark).
161 #
162
163 #
164 # Cairo is part of Mac OS X 10.6 (and, I think, 10.5).
165 # However, it's an X11 library; if we build with "native" GTK+ rather
166 # than X11 GTK+, we might have to build and install Cairo.
167 #
168 # echo "Downloading, building, and installing Cairo:"
169 # curl -O http://cairographics.org/releases/cairo-1.10.2.tar.gz || exit 1
170 # tar xvfz cairo-1.10.2.tar.gz || exit 1
171 # cd cairo-1.10.2
172 # ./configure --enable-quartz=no || exit 1
173 # make -j 3 || exit 1
174 # $DO_MAKE_INSTALL || exit 1
175 # cd ..
176
177 echo "Downloading, building, and installing ATK:"
178 atk_dir=`expr $ATK_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
179 curl -O http://ftp.gnome.org/pub/gnome/sources/atk/$atk_dir/atk-$ATK_VERSION.tar.bz2 || exit 1
180 bzcat atk-$ATK_VERSION.tar.bz2 | tar xf - || exit 1
181 cd atk-$ATK_VERSION
182 ./configure || exit 1
183 make -j 3 || exit 1
184 $DO_MAKE_INSTALL || exit 1
185 cd ..
186
187 echo "Downloading, building, and installing Pango:"
188 pango_dir=`expr $PANGO_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
189 curl -L -O http://ftp.gnome.org/pub/gnome/sources/pango/$pango_dir/pango-$PANGO_VERSION.tar.bz2
190 bzcat pango-$PANGO_VERSION.tar.bz2 | tar xf - || exit 1
191 cd pango-$PANGO_VERSION
192 ./configure || exit 1
193 make -j 3 || exit 1
194 $DO_MAKE_INSTALL || exit 1
195 cd ..
196
197 echo "Downloading, building, and installing gdk-pixbuf:"
198 gdk_pixbuf_dir=`expr $GDK_PIXBUF_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
199 curl -L -O http://ftp.gnome.org/pub/gnome/sources/gdk-pixbuf/$gdk_pixbuf_dir/gdk-pixbuf-$GDK_PIXBUF_VERSION.tar.bz2 || exit 1
200 bzcat gdk-pixbuf-$GDK_PIXBUF_VERSION.tar.bz2 | tar xf - || exit 1
201 cd gdk-pixbuf-$GDK_PIXBUF_VERSION
202 ./configure --without-libtiff --without-libjpeg || exit 1
203 make -j 3 || exit 1
204 $DO_MAKE_INSTALL || exit 1
205 cd ..
206
207 echo "Downloading, building, and installing GTK+:"
208 gtk_dir=`expr $GTK_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
209 curl -L -O http://ftp.gnome.org/pub/gnome/sources/gtk+/$gtk_dir/gtk+-$GTK_VERSION.tar.bz2
210 bzcat gtk+-$GTK_VERSION.tar.bz2 | tar xf - || exit 1
211 cd gtk+-$GTK_VERSION
212 ./configure || exit 1
213 make -j 3 || exit 1
214 $DO_MAKE_INSTALL || exit 1
215 cd ..
216
217 #
218 # Now we have reached a point where we can build everything including
219 # the GUI (Wireshark), but not with any optional features such as
220 # SNMP OID resolution, some forms of decryption, Lua scripting, playback
221 # of audio, or GeoIP mapping of IP addresses.
222 #
223 # We now conditionally download optional libraries to support them;
224 # the default is to download them all.
225 #
226
227 if [ ! -z $LIBSMI_VERSION ]
228 then
229         echo "Downloading, building, and installing libsmi:"
230         curl -L -O ftp://ftp.ibr.cs.tu-bs.de/pub/local/libsmi/libsmi-$LIBSMI_VERSION.tar.gz || exit 1
231         tar xf libsmi-$LIBSMI_VERSION.tar.gz || exit 1
232         cd libsmi-$LIBSMI_VERSION
233         ./configure || exit 1
234         make -j 3 || exit 1
235         $DO_MAKE_INSTALL || exit 1
236         cd ..
237 fi
238
239 if [ ! -z $LIBGPG_ERROR_VERSION ]
240 then
241         echo "Downloading, building, and installing libgpg-error:"
242         curl -L -O ftp://ftp.gnupg.org/gcrypt/libgpg-error/libgpg-error-$LIBGPG_ERROR_VERSION.tar.bz2 || exit 1
243         bzcat libgpg-error-$LIBGPG_ERROR_VERSION.tar.bz2 | tar xf - || exit 1
244         cd libgpg-error-$LIBGPG_ERROR_VERSION
245         ./configure || exit 1
246         make -j 3 || exit 1
247         $DO_MAKE_INSTALL || exit 1
248         cd ..
249 fi
250
251 if [ ! -z $LIBGCRYPT_VERSION ]
252 then
253         #
254         # libgpg-error is required for libgcrypt.
255         #
256         if [ -z $LIBGPG_ERROR_VERSION ]
257         then
258                 echo "libgcrypt requires libgpg-error, but you didn't install libgpg-error." 1>&2
259                 exit 1
260         fi
261
262         echo "Downloading, building, and installing libgcrypt:"
263         curl -L -O ftp://ftp.gnupg.org/gcrypt/libgcrypt/libgcrypt-$LIBGCRYPT_VERSION.tar.gz || exit 1
264         tar xf libgcrypt-$LIBGCRYPT_VERSION.tar.gz || exit 1
265         cd libgcrypt-$LIBGCRYPT_VERSION
266         #
267         # The assembler language code is not compatible with the OS X
268         # x86 assembler (or is it an x86-64 vs. x86-32 issue?).
269         #
270         ./configure --disable-asm || exit 1
271         make -j 3 || exit 1
272         $DO_MAKE_INSTALL || exit 1
273         cd ..
274 fi
275
276 if [ ! -z $GNUTLS_VERSION ]
277 then
278         #
279         # GnuTLS requires libgcrypt (or nettle, in newer versions).
280         #
281         if [ -z $LIBGCRYPT_VERSION ]
282         then
283                 echo "GnuTLS requires libgcrypt, but you didn't install libgcrypt" 1>&2
284                 exit 1
285         fi
286
287         echo "Downloading, building, and installing GnuTLS:"
288         curl -L -O http://ftp.gnu.org/gnu/gnutls/gnutls-$GNUTLS_VERSION.tar.bz2 || exit 1
289         bzcat gnutls-$GNUTLS_VERSION.tar.bz2 | tar xf - || exit 1
290         cd gnutls-$GNUTLS_VERSION
291         #
292         # Use libgcrypt, not nettle.
293         # XXX - is there some reason to prefer nettle?  Or does
294         # Wireshark directly use libgcrypt routines?
295         #
296         ./configure --with-libgcrypt || exit 1
297         make -j 3 || exit 1
298         #
299         # The pkgconfig file for GnuTLS says "requires zlib", but OS X,
300         # while it supplies zlib, doesn't supply a pkgconfig file for
301         # it.
302         #
303         # Patch the GnuTLS pkgconfig file not to require zlib.
304         #
305         patch -p0 lib/gnutls.pc <../../macosx-support-lib-patches/gnutls-pkgconfig.patch || exit 1
306         $DO_MAKE_INSTALL || exit 1
307         cd ..
308 fi
309
310 if [ ! -z $LUA_VERSION ]
311 then
312         echo "Downloading, building, and installing Lua:"
313         curl -L -O http://www.lua.org/ftp/lua-$LUA_VERSION.tar.gz || exit 1
314         tar xf lua-$LUA_VERSION.tar.gz || exit 1
315         cd lua-$LUA_VERSION
316         make -j 3 macosx || exit 1
317         $DO_MAKE_INSTALL || exit 1
318         cd ..
319 fi
320
321 if [ ! -z $PORTAUDIO_VERSION ]
322 then
323         echo "Downloading, building, and installing PortAudio:"
324         curl -L -O http://www.portaudio.com/archives/$PORTAUDIO_VERSION.tgz || exit 1
325         tar xf $PORTAUDIO_VERSION.tgz || exit 1
326         cd portaudio
327         ./configure || exit 1
328         make -j 3 || exit 1
329         $DO_MAKE_INSTALL || exit 1
330         cd ..
331 fi
332
333 if [ ! -z $GEOIP_VERSION ]
334 then
335         echo "Downloading, building, and installing GeoIP API:"
336         curl -L -O http://geolite.maxmind.com/download/geoip/api/c/GeoIP-$GEOIP_VERSION.tar.gz || exit 1
337         tar xf GeoIP-$GEOIP_VERSION.tar.gz || exit 1
338         cd GeoIP-$GEOIP_VERSION
339         ./configure || exit 1
340         make -j 3 || exit 1
341         $DO_MAKE_INSTALL || exit 1
342         cd ..
343 fi
344
345 echo ""
346
347 echo "You are now prepared to build Wireshark. To do so do:"
348 echo "./autogen.sh"
349 echo "./configure"
350 echo "make -j 3"
351 echo "make install"
352
353 echo ""
354
355 echo "Make sure you are allowed capture access to the network devices"
356 echo "See: http://wiki.wireshark.org/CaptureSetup/CapturePrivileges"
357
358 echo ""
359
360 exit 0